/*******************************************************************
*                                                                  *
*								GCALC                              *
*	This is a simple Gui Calculator application. The input stream  *
*   is passed to YACC machine as input. The user can input your    *
*   own test case either by mouse or by keyboard.                  *
*                                                                  *
*   By Jenny Luo                                                   *
*                                                                  *
*   PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.      *
*   Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.               *
*                                                                  *
*******************************************************************/          
#include <afxwin.h>
#include "resource.h"
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdio.h>

#include "public.h"     /* define global information */
#include "dcalc.h"
#include "abxlex.hpp"
#include "abxyacc.hpp"

FILE    *yyin;          /* pointer to input stream */
char yyerrsrc[TEXTLEN]; /* input filename */ 
char result[TEXTLEN];		/* expression result */
int c;
int HEXFLAG = 0;		/* hex flag */

extern int zero_flag;	/* flag for zero divider */
extern int yylineno;    /* current line number defined in lex.l */
extern int yyerrcnt;    /* count of errors, defined in err_skel.c */

/* Define an application object */
class CCalcApp:public CWinApp
{
  public: 
	virtual BOOL InitInstance();
};

/* Create an instance of the application */ 
CCalcApp CalcApp;

/* Define the window object */
class CCalcWin:public CFrameWnd
{   
	CMenu *menu;
  public:
    CCalcWin(); 
    afx_msg void OnPrompt();
    afx_msg void OnExit();
    DECLARE_MESSAGE_MAP();
}; 

/* Message map */
BEGIN_MESSAGE_MAP(CCalcWin, CFrameWnd)
	ON_COMMAND(ID_FILE_PROMPT, OnPrompt)
	ON_COMMAND(ID_FILE_EXIT, OnExit) 
END_MESSAGE_MAP()                  

/* Define the prompt dialog class */
class CPromptDialog : public CDialog
{
  private:
    CString inputString;
    CWnd *CE;          	/* window pointer to editor control */
  public:
  	CPromptDialog(CString initString, CWnd *pParentWnd);
  	BOOL OnInitDialog();              	/* send message to dialog window */
  	afx_msg LONG OnKD(UINT, LONG);		/* handle the message sent from OnInitDialog */   
  	afx_msg void OnButton0();
  	afx_msg void OnButton1();
  	afx_msg void OnButton2();          
  	afx_msg void OnButton3();
  	afx_msg void OnButton4();
  	afx_msg void OnButton5();
  	afx_msg void OnButton6();
  	afx_msg void OnButton7();
  	afx_msg void OnButton8();
  	afx_msg void OnButton9();
  	afx_msg void OnButton10();
  	afx_msg void OnButton11();
  	afx_msg void OnButton12();
  	afx_msg void OnButton13();
  	afx_msg void OnButton14();
  	afx_msg void OnButton15();
  	afx_msg void OnButton16();
  	afx_msg void OnButton17();
  	afx_msg void OnButton18();
  	afx_msg void OnButton19();
	afx_msg void OnKeyboardInput();		/* handle keyboard input */ 
    DECLARE_MESSAGE_MAP();
};  	

BEGIN_MESSAGE_MAP(CPromptDialog, CDialog)
	ON_MESSAGE(WM_USER+1, OnKD)
	ON_BN_CLICKED(ID_BUTTON0, OnButton0)
	ON_BN_CLICKED(ID_BUTTON1, OnButton1)
	ON_BN_CLICKED(ID_BUTTON2, OnButton2)
	ON_BN_CLICKED(ID_BUTTON3, OnButton3)
	ON_BN_CLICKED(ID_BUTTON4, OnButton4)
	ON_BN_CLICKED(ID_BUTTON5, OnButton5)
	ON_BN_CLICKED(ID_BUTTON6, OnButton6)
	ON_BN_CLICKED(ID_BUTTON7, OnButton7)
	ON_BN_CLICKED(ID_BUTTON8, OnButton8)
	ON_BN_CLICKED(ID_BUTTON9, OnButton9)
	ON_BN_CLICKED(ID_BUTTON10, OnButton10)
	ON_BN_CLICKED(ID_BUTTON11, OnButton11)
	ON_BN_CLICKED(ID_BUTTON12, OnButton12)
	ON_BN_CLICKED(ID_BUTTON13, OnButton13)
	ON_BN_CLICKED(ID_BUTTON14, OnButton14)
	ON_BN_CLICKED(ID_BUTTON15, OnButton15)
	ON_BN_CLICKED(ID_BUTTON16, OnButton16)
	ON_BN_CLICKED(ID_BUTTON17, OnButton17)
	ON_BN_CLICKED(ID_BUTTON18, OnButton18)
	ON_BN_CLICKED(ID_BUTTON19, OnButton19)
	ON_EN_CHANGE(ID_EDIT, OnKeyboardInput)
END_MESSAGE_MAP()                  


CPromptDialog::CPromptDialog(CString initString=NULL, 
							 CWnd *pParentWnd=NULL)     
                             : CDialog("MAINCALC", pParentWnd)
{                     
	inputString = initString;                               
}

/* set initial focus to edit control */
CPromptDialog::OnInitDialog()
{
  	CDialog::OnInitDialog();
  	PostMessage(WM_USER+1,0,0);
  	return TRUE;
}

LONG CPromptDialog::OnKD(UINT a, LONG b)
{ 
	CE = GetDlgItem(ID_EDIT);
  	GotoDlgCtrl(CE);
  	
  	return 0;
}
 
/* Window constructor */
CCalcWin::CCalcWin()
{
  /* create the calc main window */
  Create(NULL, "Simple Calculator", 
         WS_OVERLAPPEDWINDOW,
         rectDefault, NULL,
         MAKEINTRESOURCE(ID_MENU));
}                                  

void CCalcWin::OnPrompt()
{                          
	
	CPromptDialog promptDialog("", this);
	promptDialog.DoModal();
} 

void CCalcWin::OnExit()
{                                  
	DestroyWindow();
}                   

void CPromptDialog::OnButton0()
{                                       
    inputString += '0';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);      	/* reset focus to edit control */
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton1()
{
    inputString += '1';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton2()
{
    inputString += '2';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton3()
{
    inputString += '3';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton4()
{
    inputString += '4';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton5()
{
    inputString += '5';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton6()
{
    inputString += '6';
	SetDlgItemText(ID_EDIT, inputString); 
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton7()
{
    inputString += '7';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton8()
{
    inputString += '8';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton9()
{
    inputString += '9';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton10()
{
    inputString += '.';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton11()
{
    inputString += '+';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton12()
{
    inputString += '-';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton13()
{
    inputString += '*';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton14()
{
    inputString += '/';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton15()
{
	char buf[TEXTLEN];
    CString messagestr;
	char *intstr;

	yylineno = 1;	
	
	intstr = (char*)inputString.GetBuffer(inputString.GetLength()+1);
	ABXLex mylex((char*)intstr);	/* a character string as input */	
	ABXYacc myyacc(&mylex);
  	myyacc.yyParse();              
  	
  	yyerrcnt = myyacc.get_yyErrorCount();

    if (yyerrcnt!=0 || zero_flag==1)	/* find error */
    { 
	  if (zero_flag==1)
		yyerrcnt = 1;
      _itoa(yyerrcnt, buf, 10);
      messagestr += buf;
      messagestr += " error";   
      if (yyerrcnt==1)
         ;
      else
        messagestr += 's';
      
      messagestr += " found by the parser\n";
      
   	  MessageBox(messagestr, "Message Box", MB_OKCANCEL); 
  
	  /* clear the last execution result */
      inputString.Empty();
      SetDlgItemText(ID_EDIT, inputString);
    }
    else				/* no error */
    {
  	  inputString.Empty();
  	  inputString += result;
	  SetDlgItemText(ID_EDIT, inputString);
	  MessageBox("No syntax error was found by the parser\n", 
		         "Message Box", MB_OKCANCEL);
    }
   
    CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
	zero_flag = 0;		/* reset flag for divider 0 */
}

void CPromptDialog::OnButton16()
{
	inputString.Empty();
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton17()
{
	inputString.Empty();
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton18()
{
    inputString += '(';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnButton19()
{
    inputString += ')';
	SetDlgItemText(ID_EDIT, inputString);
	CE = GetDlgItem(ID_EDIT);
	GotoDlgCtrl(CE);
}

void CPromptDialog::OnKeyboardInput()
{
	char char_no;
	char buf[100];
	
	GetDlgItemText(ID_EDIT, buf, 100);
	
	/* get the last entered character */
	char_no = buf[strlen(buf)-1];
	
	/* is the character a legal one */
	if(! ( isdigit(char_no) || (char_no == '+') ||
	       (char_no == '-') || (char_no == '*') ||
	       (char_no == '/') || (char_no == '(') ||
	       (char_no == '.') || (char_no == ')') ||
	       (isxdigit(char_no) && HEXFLAG)       || 
	       (char_no == '=') ) )
	{
	  MessageBeep(0xFFFFFFFF);
	  CE = GetDlgItem(ID_EDIT);
	  ((CEdit *)CE)->Undo();
	}
	else
	{
	  if( char_no == '=' )
	  {
	    buf[strlen(buf)-1] = 0;
	    SetDlgItemText(ID_EDIT, buf);
	    inputString.Empty();
	    inputString += buf;
	    OnButton15();
	  } 
	  else
	  {
	    inputString.Empty();
	    inputString += buf;
	  }
	}
}

/* Initialize the CCalcApp m_pMainWnd data member */
BOOL CCalcApp::InitInstance()
{

	CPromptDialog dlg("", NULL);

	m_pMainWnd = &dlg;

	dlg.DoModal();
		
  return (TRUE); 
}
