#define WIN31  


#include <string.h>
#include "defs.h"
#include "defs2.h"

TObject	*objlst[LISTSZ], anObject;
Symbol	*symlst;
int     ocount=0;

TObject * new_object( TObject * o )
	{
	TObject *p;

	p = new TObject;
	if ( p == NULL )
		exception( "Out of heap space" );
	cpy_object( p, o );
	clr_object( o );
	return p;
	}

void cpy_object( TObject * t, TObject * f )
	{
	t->shape = f->shape;
	t->color = f->color;
	t->style = f->style;
	t->npoints = f->npoints;
	for ( int i = 0; i < f->npoints; i++ )
		{
		t->x_coord[i] = f->x_coord[i];
		t->y_coord[i] = f->y_coord[i];
		}
	}

void clr_object( TObject * o )
	{
	o->shape = LINE;
	o->color = BLACK;
	o->style = OUTLINED;
	o->npoints = 0;
	}

Symbol * findsym( char * str )
	{
	for ( Symbol *sp = symlst; sp != NULL; sp = sp->next )
		if ( strcmp(str, sp->namep) == 0 )
			return sp;

	return NULL;
	}

TObject * lookup( char * str )
	{
	TObject *result;
	char	mess[256];
	Symbol	*sp;

	sp = findsym( str );
	if ( sp != NULL )
		result = sp->value;
	else
		{
		strcpy( mess, "Unknown symbol " );
		strcat( mess, str );
		MessageBox( NULL, mess, "Parser Message", MB_OK );
		result = NULL;
		}

	return result;
	}

void install( char * str, TObject * o )
	{
	Symbol *sp = findsym( str );
	if ( sp == NULL )  /* define a new symbol */
		{
		sp = new Symbol;
		if ( sp == NULL )
			exception( "Out of heap space" );
		sp->next = symlst;
		symlst = sp;
		}
	else     /* symbol already exists, so override old definition */
		{
		delete sp->value;
		}

	sp->value = o;
	sp->namep = str;
	}

void append_objlst( TObject * obj )
	{
	if ( obj != NULL )
		objlst[ocount++] = obj;
	}

void exception( char * message )
	{
	MessageBox( NULL, message, "PIC Exception", MB_OK );
	exit( 3 );
	}
